(*****************************************************************************)
(*                                                                           *)
(* Open Source License                                                       *)
(* Copyright (c) 2023 Functori --- <contact@functori.com>                    *)
(*                                                                           *)
(* Permission is hereby granted, free of charge, to any person obtaining a   *)
(* copy of this software and associated documentation files (the "Software"),*)
(* to deal in the Software without restriction, including without limitation *)
(* the rights to use, copy, modify, merge, publish, distribute, sublicense,  *)
(* and/or sell copies of the Software, and to permit persons to whom the     *)
(* Software is furnished to do so, subject to the following conditions:      *)
(*                                                                           *)
(* The above copyright notice and this permission notice shall be included   *)
(* in all copies or substantial portions of the Software.                    *)
(*                                                                           *)
(* THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR*)
(* IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,  *)
(* FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL   *)
(* THE AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER*)
(* LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING   *)
(* FROM, OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER       *)
(* DEALINGS IN THE SOFTWARE.                                                 *)
(*                                                                           *)
(*****************************************************************************)

(** The `deploy_clean_cmd.ml` module provides a subcommand for the `Factori`
application called "deploy clean" that deletes all files in the `ocaml_deploy`
directory generated by the `factori deploy` command. It can be added to the list
of subcommands that the application can handle using the `Ezcmd.V2.run`
function. Warning: this short summary was automatically generated and could be
incomplete or misleading. If you feel this is the case, please open an issue. *)

open Factori_command
open Factori_config

let deploy_clean_command =
  subcommand ~name:"deploy clean" ~args:[]
    ~doc:"cleanup leftover scenario of the `factori deploy` command" (fun () ->
      let dir = Factori_config.get_dir () in
      let deploy_path = OCaml_SDK.deploy_dir ~dir () in
      let files_to_remove = Sys.readdir deploy_path in
      Array.iter
        (fun f ->
          let f = Filename.concat deploy_path f in
          Format.printf "Removing [%s]@." f ;
          Sys.remove f)
        files_to_remove)
